<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>CRM Links Tree</title>
	<script type="text/javascript" src="js/jquery.js"></script>
	<script type="text/javascript" src="js/jquery.cookie.js"></script>
	<script type="text/javascript" src="js/jquery.hotkeys.js"></script>
	<script type="text/javascript" src="jquery.jstree.js"></script>
	<link type="text/css" rel="stylesheet" href="docs/syntax/style.css"/>
	<link type="text/css" rel="stylesheet" href="docs/style.css"/>
	<script src="../../ClientGlobalContext.js.aspx" type="text/javascript"> </script>
	<script type="text/javascript" src="docs/syntax/script.js"></script>
	<script src="js/FetchUtil.js"></script>
	<script type="text/javascript"> 
	//Set up the fecth service
	var _oService; 
	var _sOrgName = GetGlobalContext().getOrgUniqueName();
	var _sServerUrl = GetGlobalContext().getServerUrl();
	
	//Build the fecth statement
	var sFetch = "<fetch version='1.0' output-format='xml-platform' mapping='logical' distinct='false'>" +
	"<entity name='a422_link'>" +
	"<attribute name='a422_name' />" +
	"<attribute name='a422_url' />" +
	"<attribute name='a422_category' />" +
	"<attribute name='a422_linkid' />" +
	"<order attribute='a422_category' descending='false' />" +
	"</entity>" +
	"</fetch>";
	
	//Execute fecth call (FetchUtil.js) and call myCallBack funtion on success
	_oService = new FetchUtil(_sOrgName, _sServerUrl); 
	var oEntity = _oService.Fetch(sFetch, myCallBack); 



	function myCallBack(results){ 
	//Get record (entity) collection from xml response
	var records = results.getElementsByTagName("a:Entity");
	//For each record check the category.  If category is new or changed build new parent list.  Add all records as list items to unordered list
	//so JQtree and do its magic
	if (records.length > 0)
		{
		var rCat = records[0].getElementsByTagName("a:FormattedValues")[0].getElementsByTagName("a:KeyValuePairOfstringstring")[0].getElementsByTagName("b:value")[0].text;
		var rAtRoot = "";
		var rNewCat = "";
		var rName = "";
		var rLink = "";
		var sOut = ""; 
		sOut += "<ul><li><a class='pnode' href=#>" + rCat + "</a><ul>"; 

		for (var i = 0; i < records.length; i++){ 
			rAtRoot = records[i].getElementsByTagName("a:Attributes")[0].getElementsByTagName("a:KeyValuePairOfstringanyType");
			rName = rAtRoot[0].getElementsByTagName("b:value")[0].text;
			rLink = rAtRoot[1].getElementsByTagName("b:value")[0].text;
			rNewCat = records[i].getElementsByTagName("a:FormattedValues")[0].getElementsByTagName("a:KeyValuePairOfstringstring")[0].getElementsByTagName("b:value")[0].text;
			
			if (rCat != rNewCat)
			{
			rCat = rNewCat;
			sOut += "</ul></li><li><a class='pnode' href=#>" + rCat + "</a><ul>";
			}
			
			sOut += "<li style='line-height: 25px;'><a href=#>" + rName + "</a><span> | </span><input value='" + rLink + "' readonly='readonly' size='" + (rLink.length + 5) + "' /></li>";

		} 
		sOut += "</ul></li></ul>";

		//once list html is built place it in the main div tag
		document.getElementById('divLinks').innerHTML = sOut;
		
		//call jstree to convert the html list to dynamic folder tree
		$(function () {
		var tree = $("#divLinks");
		tree.bind("loaded.jstree", function (event, data) {
        tree.jstree("open_all");
		});
		$("#divLinks").jstree({ 
			"themes" : {
				"theme" : "default",
				"dots" : false,
				"icons" : true
			},
			"plugins" : [ "themes", "html_data" ]
		});
		});
		}
		//if no records were returned display no linls message
		else
		{
		document.getElementById('divLinks').innerHTML = "<h1>There are currently no links to display</h1>";
		}
		//finally expose display the main div after all processing is complete
		document.getElementById('container').style.display = 'block';
	}
	</script>
</head>
<body id="demo_body" style="background-color:#ffffff">
<h2>Public Links</h2>
<div id="container" >
<div id="divLinks" class="demo">
</div>
</div>
</body>
</html>